--- original/source/ttdlg/ttdlg.c	Tue Mar 10 01:00:00 1998
+++ modif/source/ttdlg/ttdlg.c	Mon Sep 27 14:06:20 2004
@@ -625,10 +625,18 @@
 	SendDlgItemMessage(Dialog, IDC_SERIALPORT, CB_ADDSTRING,
 			   0, (LPARAM)Temp);
       }
+
+	  if (ts->UseUSB) 
+		  SendDlgItemMessage(Dialog, IDC_SERIALPORT, CB_ADDSTRING, 0, (LPARAM)"USB");
+	  
       if (ts->ComPort<=ts->MaxComPort)
-	i = ts->ComPort-1;
+		  i = ts->ComPort-1;
       else
-	i = 0;
+	  if (ts->ComPort == USB_PORT)
+		  i = ts->MaxComPort;
+	  else
+		  i = 0;
+
       SendDlgItemMessage(Dialog, IDC_SERIALPORT, CB_SETCURSEL,i,0);
 
       SetDropDownList(Dialog, IDC_SERIALBAUD, BaudList, ts->Baud);
@@ -651,7 +659,13 @@
 	  ts = (PTTSet)GetWindowLong(Dialog,DWL_USER);
 	  if ( ts!=NULL )
 	  {
-	    ts->ComPort = (WORD)GetCurSel(Dialog, IDC_SERIALPORT);
+	    char EntName[7];
+
+		GetDlgItemText(Dialog, IDC_SERIALPORT, EntName, sizeof(EntName)-1);
+		if (strcmp(EntName, "USB") == 0)
+			ts->ComPort = USB_PORT;
+	    else
+			ts->ComPort = (WORD)GetCurSel(Dialog, IDC_SERIALPORT);
 	    ts->Baud = (WORD)GetCurSel(Dialog, IDC_SERIALBAUD);
 	    ts->DataBit = (WORD)GetCurSel(Dialog, IDC_SERIALDATA);
 	    ts->Parity = (WORD)GetCurSel(Dialog, IDC_SERIALPARITY);
@@ -944,6 +958,10 @@
 	  if (GetHNRec->ComPort==i) w = j;
 	}
       }
+
+	  if (GetHNRec->UseUSB)
+		  SendDlgItemMessage(Dialog, IDC_HOSTCOM, CB_ADDSTRING, 0, "USB");
+
       if (j>0)
 	SendDlgItemMessage(Dialog, IDC_HOSTCOM, CB_SETCURSEL,w-1,0);
       else /* All com ports are already used */
@@ -972,9 +990,14 @@
 	    if (Ok) GetHNRec->TCPPort = i;
 	    memset(EntName,0,sizeof(EntName));
 	    GetDlgItemText(Dialog, IDC_HOSTCOM, EntName, sizeof(EntName)-1);
-	    GetHNRec->ComPort = (BYTE)(EntName[3])-0x30;
-	    if (strlen(EntName)>4)
-	      GetHNRec->ComPort = GetHNRec->ComPort*10 + (BYTE)(EntName[4])-0x30;
+		if (strcmp(EntName, "USB") == 0) {
+			GetHNRec->ComPort = USB_PORT;
+		}
+		else {
+			GetHNRec->ComPort = (BYTE)(EntName[3])-0x30;
+			if (strlen(EntName)>4)
+				GetHNRec->ComPort = GetHNRec->ComPort*10 + (BYTE)(EntName[4])-0x30;
+		}
 	  }
 	  EndDialog(Dialog, 1);
 	  return TRUE;
